import 'package:quantity/quantity.dart' show Angle;

class GeoCoord {
  GeoCoord.radians({this.latRad = 0, this.longRad = 0});

  GeoCoord.degrees({num latDeg = 0, num longDeg = 0})
      : latRad = new Angle(deg: latDeg).valueSI.toDouble(),
        longRad = new Angle(deg: longDeg).valueSI.toDouble();

  GeoCoord.angles({Angle lat, Angle long})
      : latRad = lat?.valueSI?.toDouble() ?? 0,
        longRad = long?.valueSI?.toDouble() ?? 0;

  final num latRad;
  final num longRad;

  Angle get latitude => new Angle(rad: latRad);

  num get degreesLatitude => new Angle(rad: latRad).valueInUnits(Angle.degrees).toDouble();

  num get radiansLatitude => latRad;

  Angle get longitude => new Angle(rad: longRad);

  num get degreesLongitude => new Angle(rad: longRad).valueInUnits(Angle.degrees).toDouble();

  num get radiansLongitude => longRad;

  @override
  String toString() {
    final StringBuffer buf = new StringBuffer()
      ..write(degreesLatitude)
      ..write(degreesLatitude < 0 ? 'S' : 'N')
      ..write(', ')
      ..write(degreesLongitude)
      ..write(degreesLongitude < 0 ? 'W' : 'E');
    return buf.toString();
  }
}
